#include "OTP_GP_Space_Programmming_Core0.h"

/*Comment out the below macro to program the OTP space for GP1*/
//#define Program_OTP


bool bResult;
otp_data sMy_OTP_data;

/*value to be programmed */
uint32_t uiOTP_GP1[ROM_OTP_SZ_gp1]={0x12345678};
/* to be read */
uint32_t uiOTP_GP1_Read1[ROM_OTP_SZ_gp1]={0xAAAAAAAA};
/* variables to compare the program value */
uint32_t uiOTP_GP1_Read2[ROM_OTP_SZ_gp1]={0xAAAAAAAA};

int main(void)
{

	adi_initComponents();
	Program_GP1(&sMy_OTP_data,&uiOTP_GP1_Read1,&uiOTP_GP1,&uiOTP_GP1_Read2);

	while(1)
	{
		asm("nop;");
	}

}

static void Program_GP1(otp_data *iData, uint32_t *iRead_Pre_Stat,uint32_t *Program_Address, uint32_t *iRead_Post_Stat)
{
		iData->gp1= iRead_Pre_Stat;

		bResult = adi_rom_otp_get(otpcmd_gp1, iData->gp1);
		if(bResult==true)
		{
			printf("\n GP1 read is successful \n");
			iData->gp1 = Program_Address;
#ifdef Program_OTP
			bResult = adi_rom_otp_pgm(iData);
#endif
			if(bResult==true)
			{
				printf("\n GP1 programmed successfully \n");
				iData->gp1 = iRead_Post_Stat;
				bResult = adi_rom_otp_get(otpcmd_gp1, iData->gp1);
				if(bResult==true)
				{
					printf("\n GP1 read after programming is successful \n");
					int i=0;
					for(i=0;i<ROM_OTP_SZ_gp1;i++)
					{
						if(Program_Address[i]!=iRead_Post_Stat[i])
						{
							printf("\n Data in OTP is not programmed successfully at offset %d \n",i);
						}
						else
						{
							printf("\n Data in OTP programmed successfully at offset %d \n", i);
						}
					}
				}

			}
		}
}

