/*****************************************************************************
 * SSL_Core0.c
 *****************************************************************************/


#include "SSL_Core0.h"


#define SSL


void adi_mmu_Init()
{
	asm("nop;");
}
int main()
{


	adi_initComponents();

	*pREG_PORTE_FER = 0;
	*pREG_PORTE_DIR_SET  = 0xE0EE;
	int i,k=0;
	/*Led 11 to blink 5 times before it calls the ROM API */
	while(k<10){
		*pREG_PORTE_DATA_TGL  = 0x4008;
		for(i=0; i<1000000; i++);
		k++;
		}

	/*Configuring the SPU secureP registers  for boot peripheral to do secure access to memory*/
	*pREG_SPU0_SECUREP106= 0x3; //SPI2_Rx_DMA
	*pREG_SPU0_SECUREP82= 0x3; //UART0_Rx_DMA
	*pREG_SPU0_SECUREP5= 0x3; //LP0_Rx_DMA
	*pREG_SPU0_SECUREP162= 0x3; //LP0_Rx_DMA
	*pREG_SPU0_SECUREP88= 0x3; //MDMA0_SRC
	*pREG_SPU0_SECUREP89= 0x3; //MDMA0_DST


	/* ROM API Call which can be invoked based on some conditions */
	adi_rom_Boot(0x60040000,0,0,0,0x10207); /* ROM API is calling the Image stored in Sector 4 of the SPI flash */




	return 0;
}



