/*****************************************************************************
 * Return_Flag_Core0.c
 *****************************************************************************/


#include "Return_Flag_Core0.h"

#define Return_Flag

void adi_mmu_Init()
{
	asm("nop;");
}

void main()
{

	adi_initComponents();

	*pREG_SPU0_SECUREP106= 0x3; //SPI2_Rx_DMA
	*pREG_SPU0_SECUREP82= 0x3; //UART0_Rx_DMA
	*pREG_SPU0_SECUREP5= 0x3; //LP0_Rx_DMA
	*pREG_SPU0_SECUREP162= 0x3; //LP0_Rx_DMA
	*pREG_SPU0_SECUREP88= 0x3; //MDMA0_SRC
	*pREG_SPU0_SECUREP89= 0x3; //MDMA0_DST

	/* using return flag to change the RCU_SVECT0 for ARM core */
	adi_rom_Boot(0x60000000,BITM_ROM_BFLAG_RETURN,0,0,0x10207);
	adi_core_enable(ADI_CORE_SHARC0);
	adi_core_enable(ADI_CORE_SHARC1);
	while(1);
}



